QGIS Application - Bug report #20018
Server and desktop too slow with Postgis views
2018-10-04 07:32 PM - Jesus Rodriguez Marcial

Status: Feedback

Priority: Normal

Assignee:

Category: Data Provider/PostGIS

Affected QGIS version:3.4.5 Regression?: No
Operating System: Windows Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27840
Description

If a layer is defined with a view or with sq|, qgis issues a select distinct count of the id, | guess that it does that to assert that the Id is
unique. If | have a huge table, it takes some 60 seconds to execute (and naively enough, multiply it if several layers are based on the same
exact view) It causes timeouts in qgis server, and makes the map unusable. There should be a way to tell Qgis that I'm pretty sure that the
PK is valid. Adding insult to injury, | don't even want to edit the data.

History

#1 - 2019-01-21 12:35 AM - Jiirgen Fischer
- Status changed from Open to Feedback

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#2 - 2019-03-04 02:40 PM - Evgeniy Baryshkov

Jurgen Fischer wrote:

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

Same problem in QGIS 3.4.5 and 3.6

#3 - 2019-03-04 03:29 PM - Giovanni Manghi
- Affected QGIS version changed from 2.18.23 to 3.4.5
- Status changed from Feedback to Open

#4 - 2019-05-23 08:59 PM - Regis Haubourg
- Status changed from Open to Feedback

Can you try the "trust dataprovider" option that is in the project properties / data source ? That should speed up loading times a lot since this option skips
those consuming queries for views and datasources that don't have those metadata (extent, geometry type, id).
?

In my cases, with 250 big views in a project, the opening time went from 1min30s down to 4s . That was made on purpose for QGIS server use cases.
